#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <ftw.h>

#define checkError(expr,userMsg)\
    do {\
        if (!(expr)) {\
            perror(userMsg);\
            exit(EXIT_FAILURE);\
        } \
    } while (0)

int size = 0;

int processFile(const char* fPath, const struct stat* sb,
                int typeflag, struct FTW* buf) {

    size += sb->st_size;

    return 0;
}

int main(int argc, char** argv) {

    checkError(argc == 2, "args");

    struct stat fInfo;
    checkError(stat(argv[1], &fInfo) != -1, "stat");

    checkError(S_ISDIR(fInfo.st_mode), "not a dir");

    checkError(nftw(argv[1], processFile, 50, 0) != -1, "nftw");

    printf("Dir size: %dB\n", size);

    exit(EXIT_SUCCESS);
}