#define _XOPEN_SOURCE 700
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <ftw.h>
#include <time.h>

#define checkError(expr,userMsg)\
    do {\
        if (!(expr)) {\
            perror(userMsg);\
            exit(EXIT_FAILURE);\
        } \
    } while (0)

#define SECS_IN_DAY (24*60*60)

time_t now;

int processFile(const char* fPath, const struct stat* sb,
                int typeflag, struct FTW* buf) {

    // if (S_ISREG(sb->st_mode)) {
    if (typeflag == FTW_F) { // regularni fajl

        time_t timeDif = now - sb->st_mtime;
        if (timeDif <= 10*SECS_IN_DAY) {
            printf("%s\n", fPath + buf->base);
        }
    }
    
    return 0;
}

int main(int argc, char** argv) {

    checkError(argc == 2, "args");

    struct stat fInfo;
    checkError(stat(argv[1], &fInfo) != -1, "stat");

    checkError(S_ISDIR(fInfo.st_mode), "not a dir");

    time(&now);
    //now = time(NULL);
    checkError(nftw(argv[1], processFile, 50, 0) != -1, "nftw");

    exit(EXIT_SUCCESS);
}